import gprs
from gwlogging import logger
from CommsInterface import CommsInterface

from time import sleep

class GprsCommsInterface(CommsInterface):

    def connect(self):
        if not gprs.init():
            logger.error("Failed to connect to networks")
            #power off gprs modem
            return False
        else:
            logger.info("GSM modem registered with GPRS service")
            sleep(10)
            gprs.connect()

            return self.is_up()

    def disconnect(self):
        gprs.disconnect()

    def is_up(self):
        return gprs.up()
