from datetime import datetime

from gwfileutils import writeFile


def parse(s):
    ret = []
    for i in s:
        arr = i.split("\t")
        time = datetime.utcfromtimestamp(float(arr[0]))
        d = MspData(time, arr[1], arr[2])
        ret.append(d)
    return ret


def tofile(filename, data):
    f = []
    for i in data:
        f.append("%s\t%s\t%s" % (i.time, i.mask, i.data.rstrip()))
    writeFile(filename, f)


class MspData:
    """Describes data from the msp"""

    def __init__(self, time, mask, data):
        self.time = time
        self.mask = mask
        self.data = data

    def __str__(self):
        output = "Time: %s\n" % self.time
        output += "Sensor: %s\n" % self.mask
        output += "Value: %s\n\n" % self.data
        return output
