from gwlogging import logger
from MuxSettings import MuxSettings
from BeagleIoMapping import *

from time import sleep

MUX_FOLDER = "/sys/kernel/debug/omap_mux/"
GPIO_FOLDER = "/sys/class/gpio/"
ENABLE_FILE = "export"
DIRECTION_FILE = "direction"

MUX = {}
MUX[32] = MuxSettings("gpmc_ad0", 7)
MUX[33] = MuxSettings("gpmc_ad1", 7)
MUX[34] = MuxSettings("gpmc_ad2", 7)
#MUX[35] = MuxSettings("gpmc_ad3", 7)
#commented out as it seems to fail at the mo :(


def get_number(port, number):
    logger.debug("Port: %d Number: %d" % (port, number))
    io = 32 * port + number
    logger.debug("IO Number: %s" % io)
    return io


class beagleIo:

    def __init__(self):
        logger.info("Setting up beagle IO")
#    Batter to do in startip file than in python as it will be more reliable
#        for i in MUX.keys():
#            self._setupMux_(i)
#            self._enableIo_(i)

    def _setupMux_(self, io):
        logger.info("Setup Mux: IO: %d" % (io))
        filename = MUX_FOLDER + MUX[io].fname
        logger.info("Mux file: %s" % filename)
        f = open(filename, "w")
        f.write("%d" % MUX[io].mux)
        f.close()
        logger.info("Mux file written")

    def _enableIo_(self, io):
        logger.info("Enable IO: IO: %d" % (io))
        fname = GPIO_FOLDER + ENABLE_FILE
        logger.debug("Enable File: %s" % fname)
        f = open(fname, "w")
        f.write("%d" % io)
        sleep(0.5)
        f.close()

    def on(self, io):
        logger.info("Turn on IO: %d" % io)
        fname = GPIO_FOLDER + "gpio%d" % io + "/" + DIRECTION_FILE
        logger.debug("File: %s" % fname)
        try:
            f = open(fname, "w")
            f.write("high")
            f.close()
        except IOError:
            logger.error("File does not exist.  Has IO %d been enabled" % io)

    def off(self, io):
        logger.info("Turn off IO: %d" % io)
        fname = GPIO_FOLDER + "gpio%d" % io + "/" + DIRECTION_FILE
        logger.debug("File: %s" % fname)
        try:
            f = open(fname, "w")
            f.write("low")
            f.close()
        except IOError:
            logger.error("File does not exist.  Has IO %d been enabled" % io)
