# Python GPS wrapper

from datetime import datetime, timedelta
from subprocess import Popen 
from time import sleep

from variables import GWGPS, GPS_BAUD_RATE, GPS_PORT 
from gwlogging import gw_stderr, gw_stdout


def start():
    sleep(5) # make sure it's had a chance to wake up
    start = Popen(args="%s -b %s -p %s start" %
                    (GWGPS, GPS_BAUD_RATE, GPS_PORT),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = start.wait()
    return rc


def stop():
    sleep(5)
    stop = Popen(args="%s -b %s -p %s stop" %
                    (GWGPS, GPS_BAUD_RATE, GPS_PORT),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = stop.wait()
    return rc


def list(output):
    sleep(5)
    list = Popen(args="%s -b %s -p %s -o %s list" %
                    (GWGPS, GPS_BAUD_RATE,
                    GPS_PORT, output),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = list.wait()
    return rc


def get(output, filename):
    sleep(5)
    get = Popen(args="%s -b %s -p %s -o %s get %s" %
                    (GWGPS, GPS_BAUD_RATE, GPS_PORT,
                    output, filename),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = get.wait()
    return rc


def delete(filename):
    sleep(5)
    delete = Popen(args="%s -b %s -p %s delete %s" %
                    (GWGPS, GPS_BAUD_RATE, GPS_PORT,
                    filename),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = delete.wait()
    return rc


def set_system_time():
    sleep(5)
    gps_timeout = datetime.utcnow() + timedelta(minutes=5)
    rc = 1
    while rc == 1 and datetime.utcnow() < gps_timeout:
        sys_time = Popen(args="%s -b %s -p %s -s date" %
                        (GWGPS, GPS_BAUD_RATE,
                        GPS_PORT),
                        shell=True,
                        stdout=gw_stdout,
                        stderr=gw_stderr)
        rc = sys_time.wait()
    return rc
