# Python Weather wrapper

from variables import GWWEATHER, WEATHER_BAUD_RATE, WEATHER_SERIAL_PORT
from gwlogging import gw_stdout, gw_stderr
import subprocess


def start():
    """start logging archive records"""
    start = subprocess.Popen(args="%s -b %s -p %s start" % (GWWEATHER,
                    WEATHER_BAUD_RATE, WEATHER_SERIAL_PORT),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = start.wait()
    return rc


def stop():
    """stop logging archive records"""
    stop = subprocess.Popen(args="%s -b %s -p %s stop" % (GWWEATHER,
                    WEATHER_BAUD_RATE, WEATHER_SERIAL_PORT),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = stop.wait()
    return rc


def loop():
    """download current weather data"""
    loop = subprocess.Popen(args="%s -b %s -p %s loop" % (GWWEATHER,
                    WEATHER_BAUD_RATE, WEATHER_SERIAL_PORT),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = loop.wait()
    return rc


def setper(interval):
    """set archive interval in minutes
    valid values 1, 5, 10, 15, 30, 60, and 120"""
    setper = subprocess.Popen(args="%s -b %s -p %s setper %s" % (GWWEATHER,
                    WEATHER_BAUD_RATE, WEATHER_SERIAL_PORT, interval),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = setper.wait()
    return rc


def clrlog():
    """clear the archive memory"""
    clrlog = subprocess.Popen(args="%s -b %s -p %s clrlog" % (GWWEATHER,
                    WEATHER_BAUD_RATE, WEATHER_SERIAL_PORT),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = clrlog.wait()
    return rc


def dump(output):
    """download the archive memory"""
    dump = subprocess.Popen(args="%s -b %s -o %s -p %s dump" % (GWWEATHER,
                    WEATHER_BAUD_RATE, output, WEATHER_SERIAL_PORT),
                    shell=True,
                    stdout=gw_stdout,
                    stderr=gw_stderr)
    rc = dump.wait()
    return rc
